/*
Problem: cross
Contest: UOI 2012
Solution: Optimal O(K * logN)
Author: Andrii Korotkov
*/
#include <cstdio>
#include <algorithm>

using namespace std;

#define K 100005

#define X first
#define Y second

int n,k;
pair<int,int> p[K];
int minYbegin[K],minYend[K],maxYbegin[K],maxYend[K];
int xo,yo;

int main()
{
	freopen("cross.dat","r",stdin);
	freopen("cross.sol","w",stdout);
	scanf("%d%d",&n,&k);
	for(int i = 1; i <= k; ++i)
		scanf("%d%d",&p[i].X,&p[i].Y);
	sort(p+1,p+k+1);
	// finding min and max Y coordinates on segments
	minYbegin[0] = n;
	maxYbegin[0] = 0;
	for(int i = 1; i <= k; ++i)
	{
		minYbegin[i] = min(minYbegin[i-1], p[i].Y);
		maxYbegin[i] = max(maxYbegin[i-1], p[i].Y);
	}
	minYend[k+1] = n;
	maxYend[k+1] = 0;
	for(int i = k; i >= 1; --i)
	{
		minYend[i] = min(minYend[i+1], p[i].Y);
		maxYend[i] = max(maxYend[i+1], p[i].Y);
	}
	// performing binary search
	int top = n;
	xo = yo = 0;
	int bot = -1;
	int i,j,minY,maxY;
	while(top - bot > 1)
	{
		int d = (top + bot)/2;
		bool flag = false;
		for(i = j = 1; i <= k && !flag; ++i)
		{
			for( ; j <= k && p[j].X - p[i].X <= 2 * d && !flag; ++j);
			minY = min(minYbegin[i-1], minYend[j]);
			maxY = max(maxYbegin[i-1], maxYend[j]);
			if(maxY - minY <= 2 * d)
			{
				flag = true;
				xo = min(p[i].X + d, n);
				yo = min(minY + d, n);
			}
		}
		if(flag)
			top = d;
		else
			bot = d;
	}
	printf("%d %d %d\n",top,xo,yo);
	return 0;
}