{
Problem: cross
Contest: UOI 2012
Solution: Optimal O(K * logN)
Author: Andrii Korotkov
}
{$APPTYPE CONSOLE}
{$B-,R-,O+}
const
  KK = 100005;

type
  point = record
    x,y:longint;
  end;

var
  n,k:longint;
  p:array[0..KK] of point;
  minYbegin,minYend,maxYbegin,maxYend: array[0..KK] of longint;
  xo,yo:longint;
  top,bot,d:longint;
  i,j,minY,maxY:longint;
  flag:boolean;

function min(a,b:longint):longint;
begin
  if(a < b)then
    min := a else
    min := b;
end;

function max(a,b:longint):longint;
begin
  if(a > b)then
    max := a else
    max := b;
end;

procedure sort(l,r:longint);
var
  i,j,k:longint;
  x:point;
begin
  if(l < r)then
  begin
    i := l;
    j := r;
    k := p[l + random(r - l + 1)].x;
    repeat
      while(p[i].x < k) do inc(i);
      while(p[j].x > k) do dec(j);
      if(i <= j)then
      begin
        x := p[i];
        p[i] := p[j];
        p[j] := x;
        inc(i);
        dec(j);
      end; 
    until i > j;
    sort(l,j);
    sort(i,r);
  end;
end;

begin
	assign(input,'cross.dat');
	assign(output,'cross.sol');
  reset(input);
  rewrite(output);
	read(n,k);
	for i := 1 to k do
		read(p[i].X,p[i].Y);
	sort(1,k);
	// finding min and max Y coordinates on segments
	minYbegin[0] := n;
	maxYbegin[0] := 0;
	for i := 1 to k do
	begin
		minYbegin[i] := min(minYbegin[i-1], p[i].Y);
		maxYbegin[i] := max(maxYbegin[i-1], p[i].Y);
	end;
	minYend[k+1] := n;
	maxYend[k+1] := 0;
	for i := k downto 1 do
	begin
		minYend[i] := min(minYend[i+1], p[i].Y);
		maxYend[i] := max(maxYend[i+1], p[i].Y);
	end;
	// performing binary search
	top := n;
	xo := 0;
  yo := 0;
	bot := -1;
	while(top - bot > 1)do
	begin
		d := (top + bot) div 2;
		flag := false;
    j := 1;
		for i:= 1 to k do
		begin
			while(j <= k) and (p[j].X - p[i].X <= 2 * d) and (not flag) do
        inc(j);
			minY := min(minYbegin[i-1], minYend[j]);
			maxY := max(maxYbegin[i-1], maxYend[j]);
			if(maxY - minY <= 2 * d)then
			begin
				flag := true;
				xo := min(p[i].X + d, n);
				yo := min(minY + d, n);
			end;
		end;
		if(flag)then
			top := d 
		else
			bot := d;
	end;
	writeln(top,' ',xo,' ',yo);
  close(input);
  close(output);
end.
