/*
Problem: cross
Contest: UOI 2012
Solution: Straightforward optimized with random O(min(CX * CY * K, maxop))
          where CX = maxX - minY + 1, CY = maxY - minY + 1
          When number of iterations of straightforward algorithm is more than maxop,
		  random choosed cross coordinates are checked
Author: Andrii Korotkov
*/

#include <cstdio>
#include <algorithm>

using namespace std;

#define K 100005

#define X first
#define Y second

const int maxop = 2000000;

int n,k;
pair<int,int> p[K];
int xo,yo,optd;
int minY,maxY,minX,maxX;

int random(int n)
{
	return ((long long)rand()*32768 + rand())%n;
}

int random(int a,int b)
{
	return a + random(b - a + 1);
}

int main()
{
	freopen("cross.dat","r",stdin);
	freopen("cross.sol","w",stdout);
	scanf("%d%d",&n,&k);
	minX = minY = n;
	maxX = maxY = 0;
	for(int i = 0; i < k; ++i)
	{
		scanf("%d%d",&p[i].X,&p[i].Y);
		minX = min(minX, p[i].X);
		maxX = max(maxX, p[i].X);
		minY = min(minY, p[i].Y);
		maxY = max(maxY, p[i].Y);
	}
	optd = n;
	xo = yo = 0;
	if((long long)(maxX - minX + 1) * (maxY - minY + 1) * k < maxop)
	{
		for(int i = minX; i <= maxX; ++i)
			for(int j = minY; j <= maxY; ++j)
			{
				int d = 0;
				for(int l = 0; l < k; ++l)
					d = max(d, min(abs(p[l].X - i), abs(p[l].Y - j)));
				if(d < optd)
				{
					optd = d;
					xo = i;
					yo = j;
				}
			}
	}else
	{
		//almost definitely will be wrong
		for (int s = 0; s < maxop / k; ++s)
		{
			int i = random(minX,maxX);
			int j = random(minY,maxY);
			int d = 0;
			for(int l = 0; l < k; ++l)
				d = max(d, min(abs(p[l].X - i), abs(p[l].Y - j)));
			if(d < optd)
			{
				optd = d;
				xo = i;
				yo = j;
			}
		}
	}
	printf("%d %d %d\n",optd,xo,yo);
	return 0;
}